/* WI_M0_2Box__Trend__h.ino
 *  Modified for the M0 1Box project (Adafruit QT-PY in the small Hammond box 1551H).
 *  2021-02-22 prefontDon@gmail.com
 *  "Soft RTC" Reference: https://learn.adafruit.com/adafruit-adalogger-featherwing/adafruit2-rtc-with-arduino
 *  u8x8 library: https://www.arduinolibraries.info/libraries/u8g2 and https://github.com/olikraus/u8g2/wiki/fntlist8x8
*/ 
//#include <ArduinoLowPower.h> // Available if you wish to use it instead of "delay()".
int redLED = A1;               // Pin A1 is output to the red LED.
//int greenLED = Ax;           // Not used in this configuration. Set the pin number for your microcontroller.
//int blueLED = Ax;

//int LDR = Ax;                // Pin Ax is output from LDR device.

int PIRpin = 6;                // Pin A3 input from PIR (passive infrared) motion sensor.
int pirState = LOW;            // We'll start with a LOW state: no motion was detected.

//int buzzer = Ax;             // Pin Ax is output to the buzzer.

/* OPTIONAL: 4-character 7-segment LED matrix. 
#include "Adafruit_LEDBackpack.h"                // For backpacks with 3 Address Select pins: 0x70 thru 0x77.
Adafruit_7segment matrix7 = Adafruit_7segment(); // Quad 7-segment LED module with I2C backpack.
*/
/* Piezo buzzer 
int numTones = 3;                          
int Tones[] = {392, 415, 440};  // The melody is comprised of the last 3 tones. Total of 10 tones listed below.
//int Tones[] = {261, 277, 294, 311, 330, 349, 370, 392, 415, 440};
//             mid C   C#   D    D#   E    F    F#   G    G#   A
*/

#include <U8x8lib.h>           // RAM-economical text-only OLED display driver! Ideal for ATmega328 microcontrollers.
//U8X8_SH1106_128X64_NONAME_HW_I2C u8x8(/* reset=*/ U8X8_PIN_NONE);   // 4-pin I2C 1.3" 128x64 OLED with no Reset.
  U8X8_SSD1306_128X64_NONAME_HW_I2C u8x8(/* reset=*/ U8X8_PIN_NONE);  // 4-pin I2C 1.3" 128x64 OLED with no Reset.

#include <Wire.h>                     // For I2C (SCL, SDA pins).                    
#include <Adafruit_Sensor.h>          // For all Adafruit sensors. 
#include <Adafruit_BME280.h>          // BME280 sensor: temperature, humidity, barometric pressure.
Adafruit_BME280 bme;                  // Uses I2C. Object name is "bme".
#define SEALEVELPRESSURE_HPA (1008.00)// Google "barometric pressure YourCity" to get the current value for determining altitude.
                                      // Altitude is not very accurate so I don't use it.                                         
#include <RTClib.h>                   // "Soft" Real time clock library used with Cortex M0/M4, etc.
RTC_Millis rtc;                       // Taken from "softrtc.ino" example in RTClib library. Object name is "rtc".
//RTC_DS1307 rtc;                     // We use LiPo backed up hard clock in this project. 
//RTC_PCF8523 rtc;                    // We switched from the DS1307 to the PCF8523 due to its better accuracy.
                                      // Comment-out the hardware RTC line and uncomment the "RTC_Millis rtc" line to run soft clock.
                                      //char daysOfTheWeek[7][12] = {"Su", "Mo", "Tu", "We", "Th", "Fr", "Sa"};                 
//Include the SD library:
#include <SPI.h>                    // Hardware SPI library: D10:SS, MOSI, MISO , SCK.
#include <SD.h>                     // SD library.
File statsFile;                     // SD object name to write weather stats to; filename will be THBP.txt.

long oledOnTime = 8000;             // Milliseconds of OLED display on-time.
                                    // Note: PIR built-in "on" time value is 7 to 8s so make sure oledOnTime is a larger value.
long SdWriteTime = 15000;           // Milliseconds (60s) between stats writes to microSD card.
unsigned long currentMillis = 0;    // millis = mS since reboot. This is a copy of that value for this point in time.
unsigned long previousMillis = 0;   // mS elapsed since last "currentMillis = millis()".  
unsigned long oledMillis = 0;       // OLED on-time in ms.
unsigned long totalOledMillis = 0;  // OledMillis time since last reset.
unsigned long sdMillis = 0;         // SD time since last write.
unsigned long totalSdMillis = 0;    // 

//int arrDltaTc[10] = {3};          // Array of Tc changes.
//int k = 0;

/* Trending Parameters */
const int arrSiz = 10;              // Array Size.
float arrTc[10] = {15.9,15.8,15.7,15.6,15.5,15.4,15.3,15.2,15.1,15.0};                     // Temp. C.  
float arrH[10] = {25.9,25.8,25.7,25.6,25.5,25.4,25.3,25.2,25.1,25.0};                      // Hum. %
float arrBP[10] = {100.09,100.08,100.07,100.06,100.05,100.04,100.03,100.02,100.01,100.00}; // BP. kPa

float sumTc = 0; float avgTc = 0; 
int avgDltaTc = 0;                // Average change in Tc.
int sumArrDltaTc = 0;             // Sum of average Tc changes.

float sumH = 0; float avgH = 0;
int avgDltaH = 0;                 // Average change in H.
int sumArrDltaH = 0;              // Sum of average H changes.

float sumBP = 0; float avgBP = 0;
int avgDltaBP = 0;                // Average change in BP.
int sumArrDltaBP = 0;             // Sum of average BP changes.

int Ythbp = 0;                    // Y-axis value for outOledBig procedure.
//******************************************************************************
//******************************************************************************
void setup(void) {
  pinMode(redLED, OUTPUT);      // Set redLED pin as output to LED.
//pinMode(greenLED, OUTPUT);
//pinMode(blueLED, OUTPUT);
/*
  for (ledIndex = 0; ledIndex <3; ledIndex++) {
    pinMode(ledArray[ledIndex], OUTPUT);              
    digitalWrite(ledArray[ledIndex], HIGH);   }  // Setting common anode RGB LED pins HIGH turns them off.
*/  
//allLEDsOff(); 
  pinMode(PIRpin,INPUT);  // Large PIR outputs logical HIGH for about 7 seconds to indicate motion was sensed.
                          // Small PIR outputs a HIGH for about 3s. 
                          // With INPUT_PULLUP, it is biased at +1v.
                          
  u8x8.begin();           // Start OLED: initDisplay, clearDisplay, setPowerSave.
  u8x8.setPowerSave(0);   // Disable OLED power save function. https://github.com/olikraus/u8g2/wiki/u8x8reference#setpowersave
  u8x8.clearDisplay();    // Clears entire display, not just one line.
  
  bme.begin();            // Start BME280.                
  
  rtc.begin(DateTime(F(__DATE__), F(__TIME__)));  // Sets the RTC to the date & time this sketch was compiled.
  // Set the RTC with an explicit date & time. For January 21, 2021 at 3pm you would call: rtc.adjust(DateTime(2021, 1, 21, 15, 0, 0)); 
  
  Serial.begin(57600);          // Pass/fail diags can be seen in Serial Monitor. 
  
  Serial.print(F("Initializing SD card..."));
  pinMode(7, OUTPUT);   // Note that even if it's not used as the CS pin, the hardware SPI SS pin (usually D10, D7 in this instance)... 
                        // ...must be left as an output or the SPI SD library functions will not work. 
  if (!SD.begin(7)) {
  Serial.println(F(" SD initialization failed!\n"));
    return;  }
  Serial.println(F("\nSD initialization done.\n")); 
}
//******************************************************************************
//******************************************************************************
void loop(void) {  
  monSD();                  // Monitor SD. Write stats to microSD card every SdWriteTime(60000ms, one minute).
  monPIR();                 // Monitor PIR. Display stats on OLED for oledOnTime (8000ms) whenever motion is detected.
  currentMillis = millis(); // Update the current time after each loop pass. Used to determine if either counter above expired.
  monTc();                  // Compute change in Tc for trending purposes. 
  delay(1000);
//monH();                   // Compute change in H for trending purposes.   
//monBP();                  // Compute change in BP for trending purposes.      
//LowPower.deepSleep(1000); // LowPower.deepSleep(milliseconds);
//millsPlot();              // Use "millsPlot" and Serial Plotter to plot just barometric pressure. Start it after the sketch downloads.
//millsTS();                // Use "millsTS" to troubleshoot your system.
}  
//******************************************************************************
void monSD(void) {  /* microSD Monitoring Code: periodically write the WI stats to a microSD card. */ 
  totalSdMillis = totalSdMillis + (currentMillis - previousMillis);      
  if(totalSdMillis >=  SdWriteTime) {   // Write stats to SD and play tone if time between SD writes exceeds threshold.
    totalSdMillis = 0;  
    outSD(); }
}
//******************************************************************************
void monPIR(void) {  /* PIR Monitoring Code: OLED displays only when motion is detected or there is a change in stats. */    
  totalOledMillis = totalOledMillis + (currentMillis - previousMillis); 
  if((digitalRead(PIRpin) == LOW)  && (totalOledMillis < oledOnTime))  { /* NO movement. */
    pirState = LOW;  
    offLED();                     // Turn off the LED.
  } else 
  if((digitalRead(PIRpin) == LOW) && (totalOledMillis >= oledOnTime))  { /* NO movement. */
    pirState = LOW; 
    totalOledMillis = 0; 
    u8x8.clearDisplay();    // Clear the OLED display.
    offLED();               // Turn off the LED.
  } else
  if((digitalRead(PIRpin) == HIGH) && (totalOledMillis < oledOnTime))  { /* Movement! */
    pirState = HIGH; 
    onLED();                // Turn on the LED.
    outOLEDbig();           // Display just T, F and BP in large font.
    u8x8.clearDisplay(); 
    delay(10);
    outOLED();              // Display the OLED info.
    u8x8.clearDisplay();    // Clear the OLED display.
  } else 
  if((digitalRead(PIRpin) == HIGH)  && (totalOledMillis >= oledOnTime))  { /* Movement! */
    pirState = HIGH; 
    totalOledMillis = 0;   
    u8x8.clearDisplay();          // Clear the OLED display to stop displaying the stats.
    offLED();                     // Turn off the LED.
  }
  previousMillis = currentMillis; // Remember the new current time.
}
//******************************************************************************
void outOLEDbig(void) {          // Displays T, H and BP in larger font.
  DateTime now = rtc.now();      // Must be in each function's scope.
  u8x8.clearDisplay();  

  Ythbp = 0;                         // Y-column position for T, H and BP.
  float Tc = bme.readTemperature();  // Temp in C.  
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f);                // https://github.com/olikraus/u8g2/wiki/fntlist8x8
  u8x8.drawString(3,Ythbp,"T:");     // T:    
  u8x8.setCursor(8,Ythbp);           // This is where the trending arrow will be inserted later.  
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f);                                 
  u8x8.print(Tc,0);                  // T: xx
  u8x8.drawString(13,Ythbp,"c");     // T: xxc   
  delay(10);
  Ythbp = 3;       
  float H = bme.readHumidity();       // Humidity %.
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); 
  u8x8.drawString(3,Ythbp,"H: ");     // H:          
  u8x8.setCursor(8,Ythbp);            // This is where the trending arrow will be inserted later.   
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f);            
  u8x8.print(H,0);                    // H: xx
  u8x8.setFont(u8x8_font_px437wyse700b_2x2_f); // Supports "%" symbol.     // https://github.com/olikraus/u8g2/wiki/fntlist8x8
  u8x8.drawString(13,Ythbp,"%");      // H: xx%        
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); // No "%" symbol.
  delay(10);
  Ythbp = 6;      
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000). 
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); 
  u8x8.drawString(1,Ythbp,"BP: ");    // BP:     
  u8x8.setCursor(8,Ythbp);            // This is where the trending arrow will be inserted later.
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); 
  u8x8.print(BP,0);                   // BP: xxx
  u8x8.drawString(14,Ythbp,"k");      // BP: xxx k // KiloPascals 

  Ythbp = 0;                          // Reset Y column pointer back to Tc position.
    
  delay(2500);                         // 2.5s: time to read the large print.
}
//****************************************************************************** 
void downArrow() {  /* Down arrow used by the Trending routine */
  u8x8.setFont(u8x8_font_open_iconic_arrow_2x2);  // https://github.com/olikraus/u8g2/wiki/fntlist8x8 Choose U8x8 Fonts then search for "iconic_arrow".
  u8x8.drawString(6,Ythbp,"\x44");                // Down arrow. https://github.com/olikraus/u8g2/wiki/u8x8reference#drawglyph
  delay(500);
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); // https://github.com/olikraus/u8g2/wiki/fntlist8x8 
}                                                           // In right panel choose U8x8 Fonts, then search for "scumm".  
//******************************************************************************
void upArrow() {     /* Up arrow used by the Trending routine */
  u8x8.setFont(u8x8_font_open_iconic_arrow_2x2);
  u8x8.drawString(6,Ythbp,"\x47");                          // Up arrow.
  delay(500);
  u8x8.setFont(u8x8_font_lucasarts_scumm_subtitle_r_2x2_f); 
}  
//******************************************************************************
void outOLED() {
  DateTime now = rtc.now();                  // Must be in each function's scope.
  u8x8.setFont(u8x8_font_chroma48medium8_r); // Font chosen.
  u8x8.drawString(0,0," WEATHER INSIDE");    // Display the program title. 
  u8x8.drawString(0,2,"T: ");                // Display Temperature in C (default) and F.
  u8x8.setCursor(4,2);
  float Tc = bme.readTemperature();          // Temp in C.
  u8x8.print(Tc,0); 
  u8x8.drawString(6,2,"c");                               
  u8x8.setCursor(8,2);
  float Tf = ((Tc * 1.8) + 32);     // Temp in F.
  u8x8.print(Tf,0);     
  u8x8.drawString(10,2,"f");  
  u8x8.drawString(0,3,"H: ");       // Display Humidity in %.
  u8x8.setCursor(4,3);
  float H = bme.readHumidity();     // Humidity %.
  u8x8.print(H,0);
  u8x8.drawString(6,3,"%");
  u8x8.drawString(0,4,"DP:");       // Display Dew Point in C and F.
  u8x8.setCursor(4,4);
  float TDPc = ((100 - H) / 5);     // Dew Point temperature in C.
  u8x8.print(TDPc,0);
  u8x8.drawString(6,4,"c"); 
  u8x8.setCursor(8,4);  
  float TDPf = ((TDPc * 1.8) + 32); // Dew Point temperature in F.
  u8x8.print(TDPf,0);
  u8x8.drawString(10,4,"f");  
  u8x8.drawString(0,5,"HX: ");      // Display Humidex in C and F using formula at bottom.
  u8x8.setCursor(4,5);
  float TDPk = TDPc + 273.15;       // Dew Point temperature in K. 
  float HXc = Tc + (0.5555 * (pow(6.11,(5417.7530 * ((1/273.16) - (1/TDPk))) - 10)));  // Calculate Humidex in C based on Dew Point and Humidity.
  u8x8.print(HXc,0);
  u8x8.drawString(6,5,"c");  
  u8x8.setCursor(8,5);  
  float HXf = ((HXc * 1.8) + 32);   // Humidex in F.
  u8x8.print(HXf,0);      
  u8x8.drawString(10,5,"f"); 
  u8x8.drawString(0,6,"BP:");       // Display Barometric Pressure in kilo Pascals (kPa)
  u8x8.setCursor(4,6); 
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  u8x8.print(BP,1);
  u8x8.drawString(10,6,"kPa");  
/*  
  float BPmm = (BP * 7.50062);      // Barometric pressure in millimeters mercury (mmHg).
  u8x8.print(BPmm,1);
  u8x8.drawString(10,6,"mmHg");
  float BPin = (BP * 0.2953);       // Barometric pressure in inches mercury (inHg).
  u8x8.print(BPin,1);
  u8x8.drawString(10,6,"inHg"); 
*/
  u8x8.setCursor(0,7);              // YY/MM/DD HH:MM
  u8x8.print(now.year(),DEC);
  u8x8.drawString(2,7,"/");
    
  u8x8.setCursor(3,7);
  if (now.month() < 10) {u8x8.print("0");} // Ensure value is two digits for formatting purposes.
  u8x8.print(now.month(),DEC);
  u8x8.drawString(5,7,"/");
  
  u8x8.setCursor(6,7);
  if (now.day() < 10)    {u8x8.print("0");} // Ensure value is two digits for formatting purposes.
  u8x8.print(now.day(), DEC);    
  u8x8.drawString(8,7," ");
  
  u8x8.setCursor(9,7);
  if (now.hour() < 10)   {u8x8.print("0");} // Ensure value is two digits for formatting purposes.
  u8x8.print(now.hour(), DEC);    
  u8x8.drawString(11,7,":");
  
  u8x8.setCursor(12,7);
  if (now.minute() < 10) {u8x8.print("0");} // Ensure value is two digits for formatting purposes.
  u8x8.print(now.minute(), DEC);
  u8x8.drawString(14,7," ");
  
//u8x8.drawString(14,7,":");
//u8x8.print(now.second(), DEC);
//u8x8.setCursor(0,8);
//u8x8l.print(daysOfTheWeek[now.dayOfTheWeek()]);  
  delay(5500);                        // 5.5s time to read the small print.
//u8x8.clearDisplay();  
}
//******************************************************************************
//******************************************************************************
/* TRENDing Scheme 
 *  Part 1: 
 *  - in global settings, the Tc array (arrTc) was backfilled with a typically lower temperature in degrees C.
 *  - determine the average Tc (avgTc) for the array
 *  - compare the current Tc (arrTc[0]) with the average Tc (avgTc) for the array.
 *  - post whether the temperature is the same, higher or lower than the average by at least +- 0.5 degrees C
 *  Part 2: (INCOMPLETE, AT BOTTOM OF SKETCH)
 *  - store the temp variation deltaTc in the array arrDltaTc
 *  - determine if the current average Tc (avgTc) for this new array exceeds the arrDltaTc average
 *  - post avgDltaTc   ???????????????????????????????????????????????????????????????????
 */
void monTc() {  /* Monitor temp. */   // "arr" = array, "Dlta" = Delta or change, "Tc" = temperature in degrees celsius.  
  delay(10);                          // Optional.
  float Tc = bme.readTemperature();   // Array Tc (arrTc) has already been populated with subnormal values (15.0c).
  for (int i = arrSiz; i > 0; i--) {  // Starting from the right (array index [9]), shift the entire array to the right ONCE.
    arrTc[i] = arrTc[i-1];         }  
  arrTc[0] = Tc;                      // The current Tc is inserted into the left-most array position [0] that was opened up.
  Serial.println(" ");
  sumTc = 0;                          // Reset the sum of the Tc values in the array.
// 
  for (int j=0; j < arrSiz; j++) {    // Once the entire array (arrTc) is filled, display the entire numbered array.
    Serial.print(j); Serial.print(": "); // Number the array elements.
    Serial.print(arrTc[j],1);            // Display each array element.
    Serial.print("  ");                  // Separate each numbered element.
    sumTc += arrTc[j];           }    // Add up all of the Tc values in the array... 
    avgTc = (sumTc / arrSiz);         // ...then divide by the array size to get the average Tc value.
  Serial.print("Average Tc: ");       // Display the average temperature in degrees C.
  Serial.println(avgTc,1);            // Single digit precision.
//  
  float deltaTcFl = (arrTc[0] - avgTc);  // Current Tc (arrTc[0]) is compared to average Tc (avgTc) to yield deltaTcFl.
  int deltaTc = (int)deltaTcFl;          // Cast the float (deltaTcFl) to an integer (deltaTc) to ease calculations.
  Serial.print(" deltaTcFl: "); Serial.print(deltaTcFl);  // Print the change in Tc as a floating decimal number.
  Serial.print("\tdeltaTc: ");  Serial.print(deltaTc);    // Print the change in Tc as an integer.  
//   
  Ythbp = 0;                             // Set Y position to the first (zero) row.
  if (deltaTcFl > 0.5)    {              // Report if current Tc is higher or lower than the array average or if it's the same. 
    Serial.println("\tTc = higher "); outOLEDbig(); upArrow();
    } else 
  if (deltaTcFl < -0.5)    {
    Serial.println("\tTc = lower");   outOLEDbig(); downArrow();    
    } else
    Serial.println("\tTC = same. ");  /*(deltaTc = 0);*/   
  delay(1000);  ///////////////////////////////////////////////////////
  u8x8.clearDisplay(); ////////////////////////////////////////////////
}
//******************************************************************************+ 
void monH() {  /* Monitor humidity */ // "arr" = array, "Dlta" = Delta or change, "H" = humidity percentage %.    
  delay(10);                          // Optional.         
  float H = bme.readHumidity();       // Array H (arrH) has already been populated with subnormal values (25%).                                     
  for (int m = arrSiz; m > 0; m--) {  // Starting from the right ([9]), shift each array variable to the right ONCE.
    arrH[m] = arrH[m-1];           }  // Continue to do this every time interval until the entire array has been replaced with the current H.
  arrH[0] = H;                        // The current H is inserted into the left-most array position [0] that was opened up.
  Serial.println(" "); 
  sumH = 0;                           // Reset the sum of the H values in the array.
//
  for (int n=0; n < arrSiz; n++) {    // Once the entire array (arrH) is filled display the array.
    Serial.print(n); Serial.print(": ");
    Serial.print(arrH[n],1);         
    Serial.print("  "); 
    sumH += arrH[n];             }    // Add up all of the H values in the array... 
    avgH = (sumH / arrSiz);           // ...then divide by the array size to get the average H value.
  Serial.print("Average H: ");        // Display the average H %.
  Serial.println(avgH,1);        
//  
  float deltaHFl = (arrH[0] - avgH);  // Current H (arrH[0]) is compared to average H (avgH) to yield deltaHFl.
  int deltaH = (int)deltaHFl;         // Cast the float (deltaHFl) to an integer (deltaH) to ease calculations.
  Serial.print(" deltaHFl: "); Serial.print(deltaHFl);  // Print the change in H as a float.
  Serial.print("\t\tdeltaH: ");  Serial.print(deltaH);    // Print the change in H as an integer.  
// 
  Ythbp = 3;                          // Set Y position to the 4th row (0=1st row, 3=4th, 6=7th).
  if (deltaH > 0.5)  {                // Report if current H is higher, lower or the same. 
    Serial.println("\tH = higher "); outOLEDbig(); upArrow();
    } else 
  if (deltaH < -0.5) {   
    Serial.println("\tH = lower"); outOLEDbig(); downArrow(); 
    } else Serial.println("\tH = same. ");  /*(deltaH = 0);*/   
}
//****************************************************************************** 
void monBP() {  /* Monitor Barometric Pressure */ // "arr" = array, "Dlta" = Delta or change,  Barometric Pressure in kPa.   
  delay(10);                          // Optional.         
  float BP = bme.readPressure() / 1000.0F;        // Array BPH (arrBP) has already been populated with subnormal values (100.0kPa).                                    
  for (int p = arrSiz; p > 0; p--) {  // Starting from the right ([9]), shift each array variable to the right once.
    arrBP[p] = arrBP[p-1];         }  // Continue to do this every time interval until the entire array has been replaced with the current BP.
  arrBP[0] = BP;                      // The current BP is inserted into the left-most array position [0] that was opened up.
  Serial.println(" "); 
  sumBP = 0;                          // Reset the sum of the BP values in the array.
//   
  for (int q=0; q < arrSiz; q++) {    // Once the entire array (arrBP) is filled display the array.
    Serial.print(q); Serial.print(" "); 
    Serial.print(arrBP[q],1);         
    Serial.print("  "); 
    sumBP += arrBP[q];           }    // Add up all of the BP values in the array... 
    avgBP = (sumBP / arrSiz);         // ...then divide by the array size to get the average BP value.
  Serial.print("Average BP: ");       // Display the average BP kPa.
  Serial.println(avgBP,1);        
//   
  float deltaBPFL = (arrBP[0] - avgBP); // Current BP (arrBP[0]) is compared to average BP (avgBP) to yield deltaBPFL.
  float deltaBP = deltaBPFL;            // Removed the cast-to-int but just for BP, not Tc nor H.
//int deltaBP = (int)deltaBPFL;         // Cast the float (deltaBPFL) to an integer (deltaBP) to ease calculations.
  Serial.print(" deltaBPFL: "); Serial.print(deltaBPFL);  // Print the change in BP as a float.
  Serial.print("\tdeltaBP: ");  Serial.print(deltaBP);    // Print the change in BP as an integer.  
// 
  Ythbp = 6;                          // Set Y position to the 4th row (0=1st, 3=4th).
  if (deltaBP > 0.05)    {            // Report if current BP is higher, lower or the same. 
    Serial.println("\tBP = higher "); outOLEDbig(); upArrow();
    } else 
  if (deltaBP < (-0.5))    {
    Serial.println("\tBP = lower");   outOLEDbig(); downArrow();    
    }   
  /* (deltaBP = 0);*/   
}
//******************************************************************************   
void outSD(void) {               // Write stats periodically to the microSD card.
  DateTime now = rtc.now();  // Must be in each function's scope.
//Open the file. Note that only one file can be open at a time so you have to close the current one before opening another.
  statsFile = SD.open("THBP.txt", FILE_WRITE);      // SPI. 
  if (statsFile) {                                  // If the file opened okay, write to it and to Serial Monitor.
    Serial.println(F("\n----------- Writing stats to THBP.txt and resetting totalSdMillis counter -----------\n"));
  } else {
    Serial.println(F("\nError opening THBP.txt\n")); // Print an error to the Serial Monitor if the file didn't open.
  }      
  statsFile.print(now.year(),DEC);   // Write date and time to SD: YY/MM/DD HH:MM.
  statsFile.print(F("/"));
  statsFile.print(now.month(),DEC);
  statsFile.print(F("/"));
  statsFile.print(now.day(), DEC); 
  statsFile.print(F(" "));  
  statsFile.print(now.hour(), DEC);  
  statsFile.print(F(":"));    
  statsFile.print(now.minute(), DEC);
  statsFile.print(F(":"));
  statsFile.print(now.second(), DEC); 
  statsFile.print(F("\t\tT:\t"));   // T:xxc xxf
  float Tc = bme.readTemperature(); // Temp in C.
  statsFile.print(Tc,0);            
  statsFile.print(F("c\t")); 
  float Tf = ((Tc * 1.8) + 32);     // Temp in F.
  statsFile.print(Tf,0);
  statsFile.print(F("f"));  
  statsFile.print(F("\t\tH:\t"));   // H:%
  float H = bme.readHumidity();     // Humidity %.
  statsFile.print(H,0);
  statsFile.print(F("%"));  
  statsFile.print("\t\tDP:\t");     // DP:xxc xxf
  float TDPc = ((100 - H) / 5);     // Dew Point temperature in C.
  statsFile.print(TDPc,0);
  statsFile.print(F("c\t"));
  float TDPf = ((TDPc * 1.8) + 32); // Dew Point temperature in F.
  statsFile.print(TDPf,0);
  statsFile.print(F("f"));
  statsFile.print(F("\t\tHX:\t"));  // HX:xxc xxf
  float TDPk = TDPc + 273.15;       // Dew Point temperature in K. 
  float HXc = Tc + (0.5555 * (pow(6.11,(5417.7530 * ((1/273.16) - (1/TDPk))) - 10)));  // Calculate Humidex in C based on Dew Point and Humidity.
  statsFile.print(HXc,0);
  statsFile.print(F("c\t")); 
  float HXf = ((HXc * 1.8) + 32);   // Humidex in F.
  statsFile.print(HXf,0);  
  statsFile.print(F("f")); 
  statsFile.print(F("\t\tBP:\t"));  // HX:xxc xxf
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  float BPmm = (BP * 7.50062);      // Barometric pressure in millimeters mercury (mmHg).
  float BPin = (BP * 0.2953);       // Barometric pressure in inches mercury (inHg).
  statsFile.print(BP,1);
  statsFile.print(F(" kPa\t"));   // kilo Pascals.
  statsFile.print(BPmm,1);
  statsFile.print(F(" mmHg\t"));  // millimeters Mercury.
  statsFile.print(BPin,1);  
  statsFile.println(F(" inHg"));  // inches Mercury.
  statsFile.close();                  
}
//******************************************************************************
void onLED() {
  digitalWrite(redLED, HIGH);   // turn the LED on (HIGH is the voltage level)   
//digitalWrite(greenLED, HIGH);
//digitalWrite(blueLED, HIGH); 
  }
void offLED() {  
  digitalWrite(redLED, LOW);    // turn the LED off by making the voltage LOW
//digitalWrite(greenLED, LOW);  
//digitalWrite(blueLED, LOW);      
}
void blinkLed() {
  digitalWrite(redLED, HIGH);   // turn the LED on (HIGH is the voltage level)
//digitalWrite(greenLED, HIGH); 
//digitalWrite(blueLED, HIGH); 
  delay(100);
//LowPower.deepSleep(100);      // wait a moment
  digitalWrite(redLED, LOW);    // turn the LED off by making the voltage LOW
//digitalWrite(greenLED, LOW); 
//digitalWrite(blueLED, LOW); 
  delay(100);
//LowPower.deepSleep(100);      // wait a moment
}
//******************************************************************************
void millsTS(void) {   // For TroubleShooting purposes. Keeps track of both SD and OLED times.
  Serial.print(F("currentMillis("));
  Serial.print(currentMillis);
  Serial.print(F(" ms)"));
  Serial.print(F(" - previousMillis("));
  Serial.print(previousMillis);
  Serial.print(F(" ms)"));
  Serial.print(F(" = "));
  Serial.print(currentMillis - previousMillis);
  Serial.print(F(" ms\t")); 
  Serial.print(F("totalOledMillis = "));
  Serial.print(totalOledMillis);
  Serial.print(F(" ms\t"));
  Serial.print(F("totalSdMillis = "));
  Serial.print(totalSdMillis);
  Serial.print(F(" ms\t"));
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  float BPmm = (BP * 7.50062);      // Barometric pressure in millimeters mercury (mmHg).
  float BPin = (BP * 0.2953);       // Barometric pressure in inches mercury (inHg).
  Serial.print(F("BP = "));
  Serial.print(BP,1);
  Serial.print(F(" kPa  "));
  Serial.print(BPmm,1);
  Serial.print(F(" mmHg  "));
  Serial.print(BPin,2);
  Serial.print(F(" inHg\t"));      
  Serial.print(F("pirState = "));
  Serial.println(pirState);
}  
//******************************************************************************+ 
void millsPlot(void) {                // Plot the BP using "Tools|Serial Plotter".
  float BP = (bme.readPressure() / 1000.0F);  // Barometric pressure in kilo Pascals kPa (Pa / 1000).
  float BPmm = (BP * 7.50062);        // Barometric pressure in millimeters mercury (mmHg).
  float BPin = (BP * 0.2953);         // Barometric pressure in inches mercury (inHg).
  Serial.print("BP ");
  Serial.println(BP,1);
}  
//******************************************************************************
 /* SECONDARY ARRAY FOR LONGER TRENDING
  arrDltaTc[k] = deltaTc;              // Put changes to Tc into another array arrDltaTc.
  sumArrDltaTc =+ arrDltaTc[k];        // sumArrDltaTc = sumArrDltaTc + arrDltaTc[k]

  k++;
  if (k == arrSiz) {  
    k = 0;
    Serial.print("arrDltaTc: ");
    for (int L = arrSiz ; L > 0; L--)  {
      Serial.print(arrDltaTc[k]); 
      Serial.print("\t"); 
      k++;                             }
  }
  avgDltaTc = (sumArrDltaTc / arrSiz); 
  Serial.print("Average DltaTc: "); 
  Serial.println(avgDltaTc);
  if (k == arrSiz)     { 
    (k = 0);
    avgDltaTc = 0;
    sumArrDltaTc = 0; }
 */       
//******************************************************************************
// humidex = air temperature + (0.5555)*(e - 10.0) where e = 6.11 * exp [5417.7530 * ((1/273.16) - (1/dewpoint in kelvins))]
